

# CreateInput
<a name="API_CreateInput"></a>

**Important**  
End of support notice: On May 20,2026, Amazon will end support for Amazon IoT Events. After May 20,2026, you will no longer be able to access the Amazon IoT Events console or Amazon IoT Events resources. For more information, see [Amazon IoT Events end of support](https://docs.amazonaws.cn/iotevents/latest/developerguide/iotevents-end-of-support.html). 

Creates an input.

## Request Syntax
<a name="API_CreateInput_RequestSyntax"></a>

```
POST /inputs HTTP/1.1
Content-type: application/json

{
   "inputDefinition": { 
      "attributes": [ 
         { 
            "jsonPath": "string"
         }
      ]
   },
   "inputDescription": "string",
   "inputName": "string",
   "tags": [ 
      { 
         "key": "string",
         "value": "string"
      }
   ]
}
```

## URI Request Parameters
<a name="API_CreateInput_RequestParameters"></a>

The request does not use any URI parameters.

## Request Body
<a name="API_CreateInput_RequestBody"></a>

The request accepts the following data in JSON format.

 ** [inputDefinition](#API_CreateInput_RequestSyntax) **   <a name="iotevents-CreateInput-request-inputDefinition"></a>
The definition of the input.  
Type: [InputDefinition](API_InputDefinition.md) object  
Required: Yes

 ** [inputDescription](#API_CreateInput_RequestSyntax) **   <a name="iotevents-CreateInput-request-inputDescription"></a>
A brief description of the input.  
Type: String  
Length Constraints: Maximum length of 1024.  
Required: No

 ** [inputName](#API_CreateInput_RequestSyntax) **   <a name="iotevents-CreateInput-request-inputName"></a>
The name you want to give to the input.  
Type: String  
Length Constraints: Minimum length of 1. Maximum length of 128.  
Pattern: `^[a-zA-Z][a-zA-Z0-9_]*$`   
Required: Yes

 ** [tags](#API_CreateInput_RequestSyntax) **   <a name="iotevents-CreateInput-request-tags"></a>
Metadata that can be used to manage the input.  
Type: Array of [Tag](API_Tag.md) objects  
Required: No

## Response Syntax
<a name="API_CreateInput_ResponseSyntax"></a>

```
HTTP/1.1 201
Content-type: application/json

{
   "inputConfiguration": { 
      "creationTime": number,
      "inputArn": "string",
      "inputDescription": "string",
      "inputName": "string",
      "lastUpdateTime": number,
      "status": "string"
   }
}
```

## Response Elements
<a name="API_CreateInput_ResponseElements"></a>

If the action is successful, the service sends back an HTTP 201 response.

The following data is returned in JSON format by the service.

 ** [inputConfiguration](#API_CreateInput_ResponseSyntax) **   <a name="iotevents-CreateInput-response-inputConfiguration"></a>
Information about the configuration of the input.  
Type: [InputConfiguration](API_InputConfiguration.md) object

## Errors
<a name="API_CreateInput_Errors"></a>

For information about the errors that are common to all actions, see [Common Error Types](CommonErrors.md).

 ** InternalFailureException **   
An internal failure occurred.    
 ** message **   
The message for the exception.
HTTP Status Code: 500

 ** InvalidRequestException **   
The request was invalid.    
 ** message **   
The message for the exception.
HTTP Status Code: 400

 ** ResourceAlreadyExistsException **   
The resource already exists.    
 ** message **   
The message for the exception.  
 ** resourceArn **   
The ARN of the resource.  
 ** resourceId **   
The ID of the resource.
HTTP Status Code: 409

 ** ServiceUnavailableException **   
The service is currently unavailable.    
 ** message **   
The message for the exception.
HTTP Status Code: 503

 ** ThrottlingException **   
The request could not be completed due to throttling.    
 ** message **   
The message for the exception.
HTTP Status Code: 429

## See Also
<a name="API_CreateInput_SeeAlso"></a>

For more information about using this API in one of the language-specific Amazon SDKs, see the following:
+  [Amazon Command Line Interface V2](https://docs.amazonaws.cn/goto/cli2/iotevents-2018-07-27/CreateInput) 
+  [Amazon SDK for .NET V4](https://docs.amazonaws.cn/goto/DotNetSDKV4/iotevents-2018-07-27/CreateInput) 
+  [Amazon SDK for C\$1\$1](https://docs.amazonaws.cn/goto/SdkForCpp/iotevents-2018-07-27/CreateInput) 
+  [Amazon SDK for Go v2](https://docs.amazonaws.cn/goto/SdkForGoV2/iotevents-2018-07-27/CreateInput) 
+  [Amazon SDK for Java V2](https://docs.amazonaws.cn/goto/SdkForJavaV2/iotevents-2018-07-27/CreateInput) 
+  [Amazon SDK for JavaScript V3](https://docs.amazonaws.cn/goto/SdkForJavaScriptV3/iotevents-2018-07-27/CreateInput) 
+  [Amazon SDK for Kotlin](https://docs.amazonaws.cn/goto/SdkForKotlin/iotevents-2018-07-27/CreateInput) 
+  [Amazon SDK for PHP V3](https://docs.amazonaws.cn/goto/SdkForPHPV3/iotevents-2018-07-27/CreateInput) 
+  [Amazon SDK for Python](https://docs.amazonaws.cn/goto/boto3/iotevents-2018-07-27/CreateInput) 
+  [Amazon SDK for Ruby V3](https://docs.amazonaws.cn/goto/SdkForRubyV3/iotevents-2018-07-27/CreateInput) 